//+------------------------------------------------------------------+
//|                                     Fractal_Level_Xrust_V2.mq4 |
//|                                 Copyright  2008, XrustSolution. |
//|                                            http://xrust.ucoz.net |
//+------------------------------------------------------------------+
#property copyright "#Copyright  2008, XrustSolution.#"
#property link      "#xrust.ucoz.net#"

#property indicator_chart_window
extern int    TimeFrame=0;      //=0,  
extern int    DistanceAp=4;     //     
extern int    DistanceDn=4;     //     
extern int    MagicNumb =0;     
extern string FrApNam="Ap";     //  . 
extern string FrDnNam="Dn";     //  . 
extern color  ClAp=Lime;        //  . 
extern color  ClDn=OrangeRed;   //  . 
extern bool   alertsOn=true;
extern bool   alertsSound=true;
extern bool   comment=false;    //  
extern bool   Orders=true;
//-----------------------------------------------------------------------------+
double FrPrice;
double FrApPrice=0,FrDnPrice=0;
bool _magic;
//+----------------------------------------------------------------------------+
void init(){
  if(MagicNumb==0){_magic=false;}else{_magic=true;}
  if(TimeFrame==0){TimeFrame=Period();}
  IndicatorShortName("Factal_Level_Xrust"+TimeFrame);
  FrApNam=StringConcatenate(FrApNam,TimeFrame);
  FrDnNam=StringConcatenate(FrDnNam,TimeFrame);
  return;}
void deinit(){
  ObjectDelete(FrDnNam);
  ObjectDelete(FrApNam);
  Comment(" ");
  return;}
//+----------------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int limit;
   double tmp;
   int i, j,k;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//-----------------------------------------------------------------------------+
  if(Orders){
   if(OrdersTotal()>0){
    for(i=0;i<OrdersTotal();i++){
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
      if(OrderSymbol()==Symbol()&&OrderType()<2){
       if(_magic){
        if(OrderMagicNumber()==MagicNumb){
        ObjectDelete(FrDnNam);
        ObjectDelete(FrApNam);
        return(0);}}
       ObjectDelete(FrDnNam);
       ObjectDelete(FrApNam);        
       return(0);}}}}}
   ArrowAp();
   ArrowDn();
   string FAP=DoubleToStr((FrApPrice-DistaneAp*Point),Digits);
   string FDP=DoubleToStr((FrDnPrice+DistaneDn*Point),Digits);
   int diap=MathRound((FrApPrice-FrDnPrice)/Point);
   if(comment){Comment("TimeFrame="+TimeFrame+
                       "\nApPrice ="+FAP+
                       "\nDnPrice ="+FDP+
                       "\nFractal Channel ="
                       +diap+"Point");}
    return(0);
  }                     

//-----------------------------------------------------------------------------+
//                            |   
//-----------------------------------------------------------------------------+
   void ArrowDn(){
   FrPrice=NormalizeDouble(FindNearFractal(0,TimeFrame,MODE_LOWER),MarketInfo(Symbol(),MODE_DIGITS));
   FrPrice=NormalizeDouble(FrPrice-DistanceDn*Point,MarketInfo(Symbol(),MODE_DIGITS));
   //Comment(FrPrice);
   if(ObjectFind(FrDnNam)==0){
     if(ObjectGet(FrDnNam,OBJPROP_PRICE1)==FrPrice){return;}}
   FrDnPrice=FrPrice;  
   ObjectDelete(FrDnNam);
   SetArrow(ClDn,FrDnNam,FrDnPrice,0,1);
   WindowRedraw();
   return;} 
//-----------------------------------------------------------------------------+
//                            | 
//-----------------------------------------------------------------------------+
   void ArrowAp(){
   FrPrice=NormalizeDouble(FindNearFractal(0,TimeFrame,MODE_UPPER),MarketInfo(Symbol(),MODE_DIGITS));
   FrPrice=NormalizeDouble(FrPrice+DistaneAp*Point,MarketInfo(Symbol(),MODE_DIGITS));
   if(ObjectFind(FrApNam)==0){
     if(ObjectGet(FrApNam,OBJPROP_PRICE1)==FrPrice){return;}}
   FrApPrice=FrPrice; 
   ObjectDelete(FrApNam); 
   SetArrow(ClAp,FrApNam,FrApPrice,0,1);
   WindowRedraw();
   return;}
//-----------------------------------------------------------------------------+   
//       !!!                                                |       
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 07.10.2006                                                     |
//|   :   .   .         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy   -        (""  NULL -  )     |
//|    tf   -                      (    0       -  )         |
//|    mode -                    (MODE_LOWER|MODE_UPPER)            |
//+----------------------------------------------------------------------------+
double FindNearFractal(string sy="0", int tf=0, int mode=MODE_LOWER) {
  if (sy=="" || sy=="0") sy=Symbol();
  double f=0;
  int    d=MarketInfo(sy, MODE_DIGITS), s;
  if (d==0) if (StringFind(sy, "GBP")<0) d=4; else d=2;

  for (s=2; s<100; s++) {
    f=iFractals(sy, tf, mode, s);
    if (f!=0) return(NormalizeDouble(f, d));
  }
  Print("FindNearFractal():   ");
  return(0);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.10.2007                                                     |
//|   :    ,  OBJ_ARROW.                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    cd -                                                           |
//|    cl -                                                          |
//|    nm -                ("" -    )     |
//|    t1 -           (0  -  )                      |
//|    p1 -              (0  - Bid)                              |
//|    sz -                (0  -  )                     |
//+----------------------------------------------------------------------------+
void SetArrow(int cd, color cl, string nm="", datetime t1=0, double p1=0, int sz=0) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) t1=Time[0];
  if (p1<=0) p1=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_ARROW, 0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1    , t1);
  ObjectSet(nm, OBJPROP_PRICE1   , p1);
  ObjectSet(nm, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE, cd);
  ObjectSet(nm, OBJPROP_COLOR    , cl);
  ObjectSet(nm, OBJPROP_WIDTH    , sz);
}
//+----------------------------------------------------------------------------+




